/*
                    Trackword Problem Solution
             John S. Gray - Copyright (c) - January 1988 
*/



#include <stdio.h>

#define FALSE           (0)
#define TRUE            (1)
#define SEQS_PER_LINE   (7)            /* How many sequences to print/line  */
#define NUM_DIR         (8)            /* Number of directions to move      */
#define SEQ_LENGTH      (9)            /* Length of trackword sequence      */


struct record {                     
       char      letter;               /* trackword letter                  */
       int       visited;              /* 'boolean' TRUE if visited         */
       int       direction[NUM_DIR];   /* vector holding valid offsets      */
};


/*
   Declaration / initialization of a vector of structures - one element
   per letter in the original trackword matrix
*/


struct record m[SEQ_LENGTH] = {
        {'I',0,1,4,3,0, 0, 0, 0, 0 } ,  {'S',0,1,4,3,2,-1, 0, 0, 0 } ,
        {'A',0,0,0,3,2,-1, 0, 0, 0 } ,  {'O',0,1,4,3,0, 0, 0,-3,-2 } ,
        {'N',0,1,4,3,2,-1,-4,-3,-2 } ,  {'P',0,0,0,3,2,-1,-4,-3, 0 } ,
        {'N',0,1,0,0,0, 0, 0,-3,-2 } ,  {'X',0,1,0,0,0,-1,-4,-3,-2 } ,
        {'E',0,0,0,0,0,-1,-4,-3, 0 }
 };


int lcount=1;                          /* counts words per line             */
char seq[SEQ_LENGTH+1];                /* holds current sequence plus \0    */
	
/* 
   Recursive function track -

   sent:     pos     starting position (0-8) of current trackword 
             index   index into sequence being built
*/

void track ( pos, index )
int pos, index;
{
  register i,                          /* loop counter                      */
      offset;                          /* offset into direction vector      */

      seq[index] = m[pos].letter;      /* place the letter in the sequence  */
      m[pos].visited = TRUE;           /* mark location at this level       */

      for ( i=0; i < NUM_DIR; ++i )    /* for all directions                */
        if ( (offset = m[pos].direction[i]) &&      /* if valid (non 0) AND */ 
             !m[pos+offset].visited             )   /* not visited          */
           track( pos+offset, index+1 );            /* call self            */
           
      m[pos].visited = FALSE;          /* unmark the location at this level */

      if ( index == SEQ_LENGTH-1 ) {   /* is sequence of proper length ?    */
        seq[index+1] = '\0';           /* terminate                         */
        printf("%10s",seq);            /* display                           */
        if ( lcount++ % SEQS_PER_LINE == 0 )
           putchar('\n');              /* issue newline every 7 sequences   */
      }  
                                       /* use tail end recursion to loop -- */
      if ( pos < SEQ_LENGTH &&         /* while starting letters exist AND  */
           index == 0           )      /* when all sequences are found for  */
         track( pos+1, index );        /* the current starting letter then  */
 }                                     /* get the next starting letter      */
                                 
main()
{
 void track();

 printf("\n\nHere is a list of the 9 letter sequences found\n\n");
 track(0, 0);                          /* call track function              */
 printf("\n\nThere were %d sequences found.\n",--lcount);
}
